Attribute VB_Name = "input"
Option Explicit

Public Const Pad_ControlPad As Integer = 0
Public Const Pad_PaddleControl As Integer = 1

Public Pad_Control(1) As Long
Public Pad_GameGear As Long
Public Pad_Type(1) As Integer

Public Pad_1(1) As Integer
Public Pad_1RapidFire(1) As Integer
Public Pad_1RapidFireDown(1) As Boolean
Public Pad_1RapidFireFlip(1) As Boolean
Public Pad_2(1) As Integer
Public Pad_2RapidFire(1) As Integer
Public Pad_2RapidFireDown(1) As Boolean
Public Pad_2RapidFireFlip(1) As Boolean
Public Pad_Pause(1) As Integer

Public Pad_Down(1) As Integer
Public Pad_Left(1) As Integer
Public Pad_Right(1) As Integer
Public Pad_Up(1) As Integer

Public Pad_Paddle1(1) As Boolean
Public Pad_PaddleFlip As Boolean
Public Pad_PaddlePosition(1) As Long

Public Controller(1) As Long
Public Controller_Enable(1) As Boolean

Public Controller_1(1) As Long
Public Controller_1RapidFire(1) As Long
Public Controller_2(1) As Long
Public Controller_2RapidFire(1) As Long
Public Controller_Pause(1) As Long

Public Const JOY_BUTTON1 As Long = &H1
Public Const JOY_BUTTON2 As Long = &H2
Public Const JOY_BUTTON3 As Long = &H4
Public Const JOY_BUTTON4 As Long = &H8
Public Const JOY_BUTTON5 As Long = &H10
Public Const JOY_BUTTON6 As Long = &H20
Public Const JOY_BUTTON7 As Long = &H40
Public Const JOY_BUTTON8 As Long = &H80
Public Const JOY_BUTTON9 As Long = &H100
Public Const JOY_BUTTON10 As Long = &H200
Public Const JOY_BUTTON11 As Long = &H400
Public Const JOY_BUTTON12 As Long = &H800

Public Const JOYERR_NOERROR = 0
Public Const JOYERR_BASE As Long = 160
Public Const JOYERR_UNPLUGGED As Long = (JOYERR_BASE + 7)

Public Const JOYSTICK1 As Long = &H0
Public Const JOYSTICK2 As Long = &H1

Public Const MAXPNAMELEN = 32
Public Const MMSYSERR_BASE As Long = 0
Public Const MMSYSERR_INVALPARAM As Long = (MMSYSERR_BASE + 11)
Public Const MMSYSERR_NODRIVER As Long = (MMSYSERR_BASE + 6)

Public Declare Function joyGetDevCaps Lib "winmm.dll" Alias "joyGetDevCapsA" (ByVal id As Long, lpCaps As JOYCAPS, ByVal uSize As Long) As Long
Public Declare Function joyGetPos Lib "winmm.dll" (ByVal uJoyID As Long, pji As JoyInfo) As Long

Public Type JOYCAPS
  wMid As Integer
  wPid As Integer
  szPname As String * MAXPNAMELEN
  wXmin As Long
  wXmax As Long
  wYmin As Long
  wYmax As Long
  wZmin As Long
  wZmax As Long
  wNumButtons As Long
  wPeriodMin As Long
  wPeriodMax As Long
End Type

Public Type JoyInfo
  wXpos As Long
  wYpos As Long
  wZpos As Long
  wButtons As Long
End Type
Public Sub PaddleControlInput1()

  If Pad_Type(0) <> Pad_PaddleControl Then Exit Sub

  If Pad_PaddleFlip = False Then
    Pad_Control(0) = Pad_PaddlePosition(0)
    Pad_Control(0) = Pad_Control(0) Or 32&
    If Pad_Paddle1(0) = True Then Pad_Control(0) = Pad_Control(0) And Not 16& Else Pad_Control(0) = Pad_Control(0) Or 16&
  Else
    Pad_Control(0) = Pad_PaddlePosition(0)
    Pad_Control(0) = Pad_Control(0) And Not 32&
    If Pad_Paddle1(0) = True Then Pad_Control(0) = Pad_Control(0) And Not 16& Else Pad_Control(0) = Pad_Control(0) Or 16&
  End If
  Pad_PaddleFlip = Not Pad_PaddleFlip

End Sub

Public Sub ControllerInput()

  Dim ControllerInfo As JoyInfo
    
  If Controller_Enable(0) = False And Controller_Enable(1) = False Then Exit Sub
  
  If Controller_Enable(0) = True Then
    If joyGetPos(Controller(0), ControllerInfo) = JOYERR_NOERROR Then
      If ControllerInfo.wXpos < 16000 Then Call frmSMS.picScreen_KeyDown(Pad_Left(0), False) Else Call frmSMS.picScreen_KeyUp(Pad_Left(0), False)
      If ControllerInfo.wXpos > 48000 Then Call frmSMS.picScreen_KeyDown(Pad_Right(0), False) Else Call frmSMS.picScreen_KeyUp(Pad_Right(0), False)
      If ControllerInfo.wYpos < 16000 Then Call frmSMS.picScreen_KeyDown(Pad_Up(0), False) Else Call frmSMS.picScreen_KeyUp(Pad_Up(0), False)
      If ControllerInfo.wYpos > 48000 Then Call frmSMS.picScreen_KeyDown(Pad_Down(0), False) Else Call frmSMS.picScreen_KeyUp(Pad_Down(0), False)
      If (ControllerInfo.wButtons And Controller_1(0)) Then Call frmSMS.picScreen_KeyDown(Pad_1(0), False) Else Call frmSMS.picScreen_KeyUp(Pad_1(0), False)
      If (ControllerInfo.wButtons And Controller_2(0)) Then Call frmSMS.picScreen_KeyDown(Pad_2(0), False) Else Call frmSMS.picScreen_KeyUp(Pad_2(0), False)
      If (ControllerInfo.wButtons And Controller_1RapidFire(0)) Then Pad_1RapidFireDown(0) = True Else Pad_1RapidFireDown(0) = False
      If (ControllerInfo.wButtons And Controller_2RapidFire(0)) Then Pad_2RapidFireDown(0) = True Else Pad_2RapidFireDown(0) = False
      If (ControllerInfo.wButtons And Controller_Pause(0)) Then Call frmSMS.picScreen_KeyDown(Pad_Pause(0), False) Else Call frmSMS.picScreen_KeyUp(Pad_Pause(0), False)
    Else
      GoTo 1
    End If
  Else
    GoTo 1
  End If

1:

  If Controller_Enable(1) = True Then
    If joyGetPos(Controller(1), ControllerInfo) = JOYERR_NOERROR Then
      If ControllerInfo.wXpos < 16000 Then Call frmSMS.picScreen_KeyDown(Pad_Left(1), False) Else Call frmSMS.picScreen_KeyUp(Pad_Left(1), False)
      If ControllerInfo.wXpos > 48000 Then Call frmSMS.picScreen_KeyDown(Pad_Right(1), False) Else Call frmSMS.picScreen_KeyUp(Pad_Right(1), False)
      If ControllerInfo.wYpos < 16000 Then Call frmSMS.picScreen_KeyDown(Pad_Up(1), False) Else Call frmSMS.picScreen_KeyUp(Pad_Up(1), False)
      If ControllerInfo.wYpos > 48000 Then Call frmSMS.picScreen_KeyDown(Pad_Down(1), False) Else Call frmSMS.picScreen_KeyUp(Pad_Down(1), False)
      If (ControllerInfo.wButtons And Controller_1(1)) Then Call frmSMS.picScreen_KeyDown(Pad_1(1), False) Else Call frmSMS.picScreen_KeyUp(Pad_1(1), False)
      If (ControllerInfo.wButtons And Controller_2(1)) Then Call frmSMS.picScreen_KeyDown(Pad_2(1), False) Else Call frmSMS.picScreen_KeyUp(Pad_2(1), False)
      If (ControllerInfo.wButtons And Controller_1RapidFire(1)) Then Pad_1RapidFireDown(1) = True Else Pad_1RapidFireDown(1) = False
      If (ControllerInfo.wButtons And Controller_2RapidFire(1)) Then Pad_2RapidFireDown(1) = True Else Pad_2RapidFireDown(1) = False
      If (ControllerInfo.wButtons And Controller_Pause(1)) Then Call frmSMS.picScreen_KeyDown(Pad_Pause(1), False) Else Call frmSMS.picScreen_KeyUp(Pad_Pause(1), False)
    End If
  End If
  
End Sub
Public Sub RapidFireInput1()
  
  If Pad_1RapidFireDown(0) Then
    If Pad_1RapidFireFlip(0) = False Then
      Pad_Control(0) = Pad_Control(0) And Not 16&
    Else
      Pad_Control(0) = Pad_Control(0) Or 16&
    End If
    Pad_1RapidFireFlip(0) = Not Pad_1RapidFireFlip(0)
  End If
  
  If Pad_Type(0) = Pad_PaddleControl Then Exit Sub
  
  If Pad_2RapidFireDown(0) Then
    If Pad_2RapidFireFlip(0) = False Then
      Pad_Control(0) = Pad_Control(0) And Not 32&
    Else
      Pad_Control(0) = Pad_Control(0) Or 32&
    End If
    Pad_2RapidFireFlip(0) = Not Pad_2RapidFireFlip(0)
  End If

End Sub

Public Sub RapidFireInput2()
  
  If Pad_1RapidFireDown(1) Then
    If Pad_1RapidFireFlip(1) = False Then
      Pad_Control(1) = Pad_Control(1) And Not 4&
    Else
      Pad_Control(1) = Pad_Control(1) Or 4&
    End If
    Pad_1RapidFireFlip(1) = Not Pad_1RapidFireFlip(1)
  End If
  
  If Pad_Type(1) = Pad_PaddleControl Then Exit Sub
  
  If Pad_2RapidFireDown(1) Then
    If Pad_2RapidFireFlip(1) = False Then
      Pad_Control(1) = Pad_Control(1) And Not 8&
    Else
      Pad_Control(1) = Pad_Control(1) Or 8&
    End If
    Pad_2RapidFireFlip(1) = Not Pad_2RapidFireFlip(1)
  End If
  
End Sub


